#ifndef DEF_HEADER_ACTION_CONTROL
#define DEF_HEADER_ACTION_CONTROL

#include "action.h"
#include <SDL/SDL.h>

typedef struct _ActionControl ActionControl;
struct _ActionControl
{
	Action * action;
	Bone bone;
	int time;
};

typedef struct _ActionControlDrawer ActionControlDrawer;
struct _ActionControlDrawer
{
	ActionControl * control;
	SDL_Rect dim;
	int steps;
	int is_mouse_clic;
};

/* ActionControl */

int ActionControl_init(ActionControl * control, Action * action);

int ActionControl_select_bone(ActionControl * control, Bone bone);

int ActionControl_add_rotate(ActionControl * control);

int ActionControl_delete_rotate(ActionControl * control);

int ActionControl_set_time(ActionControl * control, int time);

int ActionControl_play_frame(ActionControl * control);

int ActionControl_continue(ActionControl * control);

/* ActionControlDrawer */

int ActionControlDrawer_init(ActionControlDrawer * drawer, ActionControl * control, int x, int y, int width, int height, int steps);

void ActionControlDrawer_draw(ActionControlDrawer * drawer, SDL_Surface * screen);

int ActionControlDrawer_gest(ActionControlDrawer * drawer, SDL_Event * event, int * mouse_used);

#endif