#ifndef DEF_HEADER_ACTION_EDIT
#define DEF_HEADER_ACTION_EDIT

#include "edit.h"
#include "armature.h"
#include "file_explorer.h"
#include "action_control.h"
#include "action.h"
#include "personnage.h"
#include "action_list.h"
#include "file_saver.h"
#include "mini_menu.h"

#define ACTION_EDIT_RANGE 50

typedef enum
{
	ACTIONEDIT_SELECT_MOVEMODE_NULL,
	ACTIONEDIT_SELECT_MOVEMODE_ROTATION,
	NB_ACTIONEDIT_SELECT_MOVEMODE
} ActionEdit_Select_MoveMode;

typedef struct _ActionEdit_Select * ActionEdit_Select;
struct _ActionEdit_Select
{
	Bone * arma;
	Bone selected_bone;
	
	SDL_Rect mouse;
	
	ActionEdit_Select_MoveMode move_mode;
	SDL_Rect start_mouse;
	SDL_Rect last_mouse;
	SDL_Rect selected_bone_start;
	double angle_start;
	double mouse_angle_start;
	
	Action * action;
	ActionStats action_stats;
	ActionControl control;
	ActionControlDrawer control_drawer;
	ActionList action_list;
	
	int (*print_arma)(Bone);
	
	Mini_Menu action_menu;
	Mini_Menu step_menu;
	Mini_Menu bone_menu;
	Mini_Menu none_menu;
};

int ActionEdit_Select_create(ActionEdit_Select * select, Personnage * perso);

void ActionEdit_Select_free(ActionEdit_Select * select);

int Action_edit(Personnage * perso, ActionEdit_Select select, EditExit * exit_choice, File_Explorer file_exp, FileSaver * file_saver);

/* Selection */

void ActionEdit_Select_draw_selection(ActionEdit_Select select);

int ActionEdit_Select_is_selection(ActionEdit_Select select);

int ActionEdit_Select_make_selection(ActionEdit_Select select, int x, int y);

int ActionEdit_Select_cancel_selection(ActionEdit_Select select);

void ActionEdit_Select_def_action(ActionEdit_Select select, Action * action);

/* MouseMove */

int ActionEdit_Select_set_mouse(ActionEdit_Select select, int x, int y);

int ActionEdit_Select_start_mouse_move(ActionEdit_Select select, int x, int y, ActionEdit_Select_MoveMode mode);

int ActionEdit_Select_end_mouse_move(ActionEdit_Select select);

int ActionEdit_Select_is_mouse_move(ActionEdit_Select select);

int ActionEdit_Select_mouse_move_selection(ActionEdit_Select select, int x, int y);

#endif