#ifndef DEF_HEADER_ARENA
#define DEF_HEADER_ARENA

#include "personnage.h"
#include "edit.h"
#include "bone_table.h"

#define GROUND 50

typedef struct _Arena Arena;
struct _Arena
{
	Personnage player;
	Personnage adv;
	
	BoneTable player_bones;
	BoneTable adv_bones;
};

int Arena_init_test(Arena * arena, Personnage player);

int Arena_init_fight(Arena * arena, Personnage player, Personnage adv);

void Arena_quit(Arena * arena);

void Arena_draw_test(Arena * arena);

void Arena_draw_fight(Arena * arena);

int Arena_play_test(Arena * arena, EditExit * exit_choice);

int Arena_play_fight(Arena * arena);

int Arena_gest_collision(Arena * arena);

int Arena_generate_background();

void Arena_free_background();

#endif