#include "button.h"
#include <stdio.h>
#include <stdlib.h>

#include "image.h"
#include "color.h"

#define BOX_WIDTH 100

static int Buttons_menu_define(Menu menu, int width, int y)
{
	SDL_Surface * rectangle = NULL;
	SDL_Surface * rectangle_hover = NULL;
	int success = 1;
	
	if(! SDL_GetMecaRectangleRGB(&rectangle, 125, 35, 19, 123, 188))
		return 0;
	if(! SDL_GetMecaRectangleRGB(&rectangle_hover, 125, 35, 23, 151, 230))
	{
		SDL_FreeSurface(rectangle);
		return 0;
	}
	success &= Menu_define_Menu_List(menu, "media/arial.ttf", 25, SDL_Color_create(255, 255, 255), rectangle, rectangle_hover);
	Menu_set_origin(menu, width / 2 - BOX_WIDTH / 2, y);
	SDL_FreeSurface(rectangle);
	SDL_FreeSurface(rectangle_hover);
	return success;
}

int Buttons_create(Buttons * buttons, int width, int y, int nb_buttons, ...)
{
	va_list ap;
	int i;
	
	if(buttons == NULL)
		return 0;
	
	buttons->menu = NULL;
	if(! Menu_create(&(buttons->menu))
	|| ! Buttons_menu_define(buttons->menu, width, y)
	|| ! Menu_alloc_elems(buttons->menu, nb_buttons))
		goto free_zone;
	va_start(ap, nb_buttons);
	for(i = 0; i < nb_buttons; ++i)
	{
		if(! Menu_define_elem(buttons->menu, i, NULL, MENU_ELEMENT_TEXT, va_arg(ap, char *), NULL))
			goto free_zone;
	}
	va_end(ap);
	
	return 1;
	
	free_zone:;
	Menu_free(&(buttons->menu));
	return 0;
}

void Buttons_free(Buttons * buttons)
{
	if(buttons == NULL)
		return;
	Menu_free(&(buttons->menu));
}

int Buttons_get_event(Buttons * buttons, SDL_Event * event, int * choix)
{
	int res_choix = -1;
	if(buttons == NULL)
		return 0;
	if(! Menu_event(buttons->menu, event, NULL, NULL, MENU_OPTION_GET_ID, &res_choix, MENU_OPTION_END))
		return 0;
	if(res_choix == -1)
		return 1;
	if(choix != NULL)
		*choix = res_choix;
	return 1;
}

void Buttons_draw(Buttons * buttons, SDL_Surface * screen)
{
	if(buttons == NULL)
		return;
	Menu_draw(buttons->menu, screen);
}