#ifndef DEF_HEADER_CHAIN_LIST
#define DEF_HEADER_CHAIN_LIST

typedef struct _ChainListElem * ChainListElem;
struct _ChainListElem
{
	void * elem;
	ChainListElem next;
};

typedef struct _ChainList * ChainList;
struct _ChainList
{
	ChainListElem list;
	ChainListElem cursor;
	int (*create_elem)(void * elem_adress, void * value);
	void (*free_elem)(void * elem_adress);
	int (*affect_elem)(void * dest_adress, void * src);
	int (*eq_elem)(void * in_list, void * elem);
};

int ChainList_create(ChainList * list,
					int (*create_elem)(void * elem_adress, void * value),
					/* if NULL, it will be an adress affectation */
					void (*free_elem)(void * elem_adress),
					/* if NULL, the adress of the elem created won't be free */
					int (*affect_elem)(void * dest_adress, void * src),
					/* if NULL, adress affect */
					int (*eq_elem)(void * in_list, void * elem));
					/* if NULL, cmp adress */

void ChainList_free(ChainList * list);

int ChainList_find(ChainList list, void * elem);

int ChainList_find_with_function(ChainList list, int (*eq_elem)(void *, void *), void * elem);

int ChainList_get_with_function(ChainList list, int (*eq_elem)(void *, void *), void * data, void * get);

int ChainList_append_head(ChainList list, void * elem);

int ChainList_append_tail(ChainList list, void * elem);

int ChainList_append_if_not_exists(ChainList list, void * elem);

int ChainList_append_if_not_exists_with_function(ChainList list, int (*eq_elem)(void *, void *), void * elem);

int ChainList_delete_head(ChainList list, void * pop_adress);

int ChainList_delete_tail(ChainList list, void * pop_adress);

int ChainList_delete_if_exists(ChainList list, void * elem);

int ChainList_delete_if_exists_with_function(ChainList list, int (*eq_elem)(void *, void *), void * elem);

void ChainList_cursor_to_start(ChainList list);

int ChainList_cursor_goto_next(ChainList list, void * get_cursor);

#endif