#ifndef DEF_HEADER_COLOR
#define DEF_HEADER_COLOR

#include <SDL/SDL.h>

#if SDL_BYTEORDER == SDL_BIG_ENDIAN

typedef enum
{
	MASK_RED = 	0xff000000,
	MASK_GREEN = 	0x00ff0000,
	MASK_BLUE =	0x0000ff00,
	MASK_ALPHA =	0x000000ff
} ColorMask;

typedef enum
{
	DECAL_RED = 24,
	DECAL_GREEN = 16,
	DECAL_BLUE = 8,
	DECAL_ALPHA = 0
} ColorDecal;

#else

typedef enum
{
	MASK_RED = 	0x000000ff,
	MASK_GREEN = 	0x0000ff00,
	MASK_BLUE =	0x00ff0000,
	MASK_ALPHA =	0xff000000
} ColorMask;

typedef enum
{
	DECAL_RED = 0,
	DECAL_GREEN = 8,
	DECAL_BLUE = 16,
	DECAL_ALPHA = 24
} ColorDecal;

#endif

Uint32 SDL_Color_to_Uint32(SDL_Color color);

SDL_Color Uint32_to_SDL_Color(Uint32 color);

void Uint32_get_values(Uint32 color, int * r, int * g, int * b, int * a);

void Uint32_set_values(Uint32 * color, int r, int g, int b, int a);

void Uint32_get_from_surface(Uint32 * color, SDL_Surface * surface, int x, int y);

void Uint32_set_on_surface(Uint32 color, SDL_Surface * surface, int x, int y);

void SDL_Color_get_from_surface(SDL_Color * color, SDL_Surface * surface, int x, int y);

void SDL_Color_set_on_surface(SDL_Color color, SDL_Surface * surface, int x, int y);

Uint32 Uint32_by_teinte(int teinte);

SDL_Color SDL_Color_get_max_teinte(int r, int g, int b);

int teinte_by_rgb(int r, int g, int b);

SDL_Color SDL_Color_create(int r, int g, int b);

SDL_Color SDL_Color_less(SDL_Color color, int intensity);

SDL_Color SDL_Color_more(SDL_Color color, int add);

SDL_Color SDL_Color_invert(SDL_Color color);

int SDL_Color_get_intensity(SDL_Color color);

int SDL_Color_get_add(SDL_Color color);

int SDL_Color_equal(SDL_Color color, SDL_Color other);

void SDL_Color_draw_triangle(SDL_Surface * screen, SDL_Color color, int x, int y, int size);

int SDL_Color_get_in_triangle(SDL_Color * color, int vx, int vy, int size);

void Color_quit();

/*
	for each color:
	SDL_Color color, int distance
*/
SDL_Color SDL_Color_by_color_distances(int nb_colors, ...);

int SDL_Color_window_gest(SDL_Color * color, SDL_Surface * screen, int x, int y, int size, void (*draw)(void * data), void * data);

/*int SDL_Surface_set_color_key(SDL_Surface * surface, int r, int g, int b);*/

#endif