#include "data_debug_print.h"

#include <stdio.h>
#include <stdlib.h>

void DP_Personnage(Personnage * perso)
{
	printf("Personnage {\n");
	printf("perso @ %p\n", perso);
	printf("perso data %p\n", *perso);
	DP_Bone(&((*perso)->armature));
	DP_ActionList(&((*perso)->actions));
	printf("} Personnage;\n");
}

static void DP_SDL_Rect(const char * header, SDL_Rect * coord, int full)
{
	printf("%s SDL_Rect(%d, %d", header, coord->x, coord->y);
	if(full)
		printf(", %d, %d", coord->w, coord->h);
	printf(")\n");
}

static void DP_SDL_Color(const char * header, SDL_Color * color)
{
	printf("%s SDL_Color(%d, %d, %d)\n", header, color->r, color->g, color->b);
}

void DP_Bone(Bone * bone)
{
	if(bone == NULL || *bone == NULL)
		return;
	printf("Bone {\n");
	printf("bone @ %p\n", bone);
	printf("bone data %p\n", *bone);
	DP_SDL_Rect("start", &((*bone)->start), 0);
	DP_SDL_Rect("end", &((*bone)->end), 0);
	printf("angle %g\n", (*bone)->angle);
	printf("start_angle %g\n", (*bone)->start_angle);
	printf("angle_min %g\n", (*bone)->angle_min);
	printf("deny_angle_area %g\n", (*bone)->deny_angle_area);
	printf("in_front_of_parent %d\n", (*bone)->in_front_of_parent);
	printf("id : ");
	DP_BinPath((*bone)->id);
	printf("shape : ");
	DP_ShapeSet(&((*bone)->shape));
	printf("child : ");
	DP_Bone(&((*bone)->child));
	printf("brother : ");
	DP_Bone(&((*bone)->brother));
	printf("} Bone;\n");
}

void DP_BinPath(BinPath path)
{
	printf("BinPath {\n");
	BinPath_aff_debug(path);
	printf("} BinPath;\n");
}

void DP_ShapeSet(ShapeSet * set)
{
	int i;
	printf("ShapeSet {\n");
	printf("set @ %p\n", set);
	printf("set data %p\n", *set);
	DP_SDL_Rect("center", &((*set)->center), 0);
	printf("nb_elems %d\n", (*set)->nb_elems);
	printf("maxi_elems %d\n", (*set)->maxi_elems);
	printf("elems->{\n");
	for(i = 0; i < (*set)->nb_elems; ++i)
	{
		printf("elems[%d] : ", i);
		DP_ShapeElem((*set)->elems + i);
	}
	printf("}->elems;\n");
	printf("} ShapeSet;\n");
}

void DP_ShapeElem(ShapeElem * elem)
{
	printf("ShapeElem {\n");
	printf("elem @ %p\n", elem);
	printf("elem data %p\n", *elem);
	DP_SDL_Color("color", &((*elem)->color));
	DP_SDL_Color("border_color", &((*elem)->border_color));
	printf("shape : ");
	DP_Shape(&((*elem)->shape));
	printf("} ShapeElem;\n");
}

void DP_Shape(Shape * shape)
{
	if(shape == NULL || *shape == NULL)
		return;
	printf("Shape {\n");
	printf("shape @ %p\n", shape);
	printf("shape data %p\n", *shape);
	DP_SDL_Rect("center", &((*shape)->center), 0);
	printf("radius %d\n", (*shape)->radius);
	printf("border %d\n", (*shape)->border);
	printf("child : ");
	DP_Shape(&((*shape)->child));
	printf("sister : ");
	DP_Shape(&((*shape)->sister));
	printf("} Shape;\n");
}

void DP_ActionList(ActionList * list)
{
	int i;
	printf("ActionList {\n");
	printf("list @ %p\n", list);
	printf("list data %p\n", *list);
	printf("nb_actions %d\n", (*list)->nb_actions);
	printf("max_nb_actions %d\n", (*list)->max_nb_actions);
	printf("actions->{\n");
	for(i = 0; i < (*list)->nb_actions; ++i)
	{
		printf("actions[%d] : ", i);
		DP_ActionStats((*list)->actions + i);
	}
	printf("}->actions\n");
	printf("} ActionList;\n");
}

void DP_ActionStats(ActionStats * stats)
{
	printf("ActionStats {\n");
	printf("stats @ %p\n", stats);
	printf("stats data %p\n", *stats);
	printf("name \"%s\"\n", (*stats)->name);
	printf("action : ");
	DP_Action(&((*stats)->action));
	printf("} ActionStats;\n");
}

void DP_Action(Action * action)
{
	if(action == NULL || *action == NULL)
		return;
	printf("Action {\n");
	printf("action @ %p\n", action);
	printf("action data %p\n", *action);
	printf("bone %p\n", (*action)->bone);
	if((*action)->bone != NULL)
	{
		printf("bone->id : ");
		DP_BinPath((*action)->bone->id);
	}
	printf("steps : ");
	DP_ActionStep(&((*action)->steps));
	printf("next_bone : ");
	DP_Action(&((*action)->next_bone));
	printf("} Action;\n");
}

void DP_ActionStep(ActionStep * step)
{
	if(step == NULL || *step == NULL)
		return;
	printf("ActionStep {\n");
	printf("step @ %p\n", step);
	printf("step data %p\n", *step);
	printf("target_angle %g\n", (*step)->target_angle);
	printf("start_time %d\n", (*step)->start_time);
	printf("#-----#\n");
	printf("real_start_time %d\n", (*step)->real_start_time);
	printf("duration %d\n", (*step)->duration);
	printf("vector_sign %d\n", (*step)->vector_sign);
	printf("#-----#\n");
	printf("last_time @ %p\n", &((*step)->last_time));
	printf("last_time data %p\n", (*step)->last_time);
	printf("next_time @ %p\n", &((*step)->next_time));
	printf("next_time data %p\n", (*step)->next_time);
	printf("next_time : ");
	DP_ActionStep(&((*step)->next_time));
	printf("} ActionStep;\n");
}