#ifndef DEF_HEADER_DIALOG
#define DEF_HEADER_DIALOG

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <stdarg.h>
#include "text_input.h"

typedef struct _Dialog Dialog;
struct _Dialog
{
	TTF_Font * font;
	SDL_Color color;
	Input input;
};

/* Surface functions */

int TextSurface_create_va(SDL_Surface ** surface, TTF_Font * font, SDL_Color color, const char * format, va_list ap);

void print_text(SDL_Surface * screen, SDL_Color color, const char * format, ...);

/* Dialog functions */

int Dialog_create(Dialog * dial, const char * path, int size, SDL_Color color);

void Dialog_free(Dialog * dial);

int Dialog_print_va(SDL_Surface * screen, Dialog * dial, const char * format, char ** alloc_text, va_list ap);

int Dialog_print(SDL_Surface * screen, Dialog * dial, const char * format, ...);

int Dialog_ask_text(SDL_Surface * screen, Dialog * dial, const char * format, char ** alloc_text, ...);

/* Dialog global */

int Dialog_global_init(const char * path, int size, SDL_Color color);

void Dialog_global_free();

int Dialog_global_print(SDL_Surface * screen, const char * format, ...);

int Dialog_global_ask_text(SDL_Surface * screen, const char * format, char ** alloc_text, ...);

#endif