#ifndef DEF_HEADER_DRAW
#define DEF_HEADER_DRAW

#include "armature.h"
#include "window.h"
#include "color.h"
#include "shape.h"
#include "image.h"
#include "personnage.h"
#include "hitbox.h"

#define ANGLE_RAD 25
#define BONE_RAD 2

typedef enum
{
	ARMADRAW_PART_NULL,
	ARMADRAW_PART_START,
	ARMADRAW_PART_END,
	ARMADRAW_PART_BONE,
	ARMADRAW_PART_IGNORE,
	NB_ARMADRAW_PART
} ArmaDraw_Part;

void draw_bone_part_startRGBA(SDL_Surface * screen, int start_x, int start_y, int end_x, int end_y, int r, int g, int b, int a);

void draw_bone_part_endRGBA(SDL_Surface * screen, int start_x, int start_y, int end_x, int end_y, int r, int g, int b, int a);

void draw_bone_part_boneRGBA(SDL_Surface * screen, int start_x, int start_y, int end_x, int end_y, int r, int g, int b, int a);

int draw_armature(Bone start);

int draw_shape_armature(Bone start);

int draw_in_armature(Bone start, Bone bone, ArmaDraw_Part part, ArmaDraw_Part angle_part);

int draw_in_armature_color(Bone start, Bone bone, ArmaDraw_Part part, ArmaDraw_Part angle_part, SDL_Color bone_color, SDL_Color angle_color, SDL_Color angle_select_color);

int draw_in_armature_color_with_alpha(Bone start, Bone bone, ArmaDraw_Part part, ArmaDraw_Part angle_part, SDL_Color bone_color, SDL_Color angle_color, SDL_Color angle_select_color, int a);

void draw_arcRGBA(SDL_Surface * dest, int x, int y, int rad, double start, double end, int r, int g, int b, int a);

void SDL_Surface_print_generic(void * surface, int x, int y);

void draw_shape(Shape shape, SDL_Color color, SDL_Color border_color, int x, int y);

void draw_shape_set(ShapeSet shape, int x, int y);

void draw_hitbox(HitBox hitbox, int x, int y);

void draw_select_shape(Bone arma, Bone bone, Shape select, SDL_Color color);

void draw_select_shape_elem(Bone arma, Bone bone, Shape select, SDL_Color color);

int ShapeSet_make_image(Image * image, ShapeSet shape);

int Armature_calculate_images(Bone arma);

int draw_action_armature(Bone start);

int draw_action_armature_real(Bone start);

int draw_action_select(Bone start, Bone select);

void Bone_draw_bone_color(SDL_Surface * screen, Bone bone, int x, int y, double angle, int r, int g, int b, int a);

void Bone_draw_bone(SDL_Surface * screen, Bone bone, int x, int y, double angle);

void Bone_draw_bone_arma(SDL_Surface * screen, Bone bone, int x, int y, double angle);

void Bone_draw_bone_shape(SDL_Surface * screen, Bone bone, int x, int y, double angle);

void Bone_draw_selected_bone(SDL_Surface * screen, Bone bone, int x, int y, double angle);

int Bone_condition_equal_bone(Bone bone, void * equal_bone);

int draw_caracter(Bone start, void (*bone_draw)(SDL_Surface *, Bone, int x, int y, double angle), void * data, int (*condition)(Bone bone, void * data));

int Personnage_draw(Personnage perso);

#endif