#include "file_saver.h"
#include "personnage.h"
#include "dialog.h"
#include "window.h"

#include <stdlib.h>

int FileSaver_create(FileSaver * saver)
{
	saver->file_name = NULL;
	return 1;
}

int FileSaver_Personnage_save(const char * path, void * perso)
{
	return Personnage_save_in_file(path, (Personnage)perso);
}

int FileSaver_Personnage_load(const char * path, void * perso_adress)
{
	return Personnage_load_from_file(path, (Personnage *)perso_adress);
}

int FileSaver_save(FileSaver * saver, File_Explorer explorer, Key_Gest * key_gest, void * data, int (*save_function)(const char * path, void * data))
{
	if(Key_Gest_key_in(key_gest, KGK_CTRL))
	{
		if(saver->file_name == NULL || Key_Gest_key_in(key_gest, KGK_SHIFT))
			File_Explorer_gest_event(explorer, get_screen(), FILE_EXPLORER_MODE_SAVE, &(saver->file_name));
		if(saver->file_name != NULL)
		{
			if(! (*save_function)(saver->file_name, data))
				Dialog_global_print(get_screen(), "Echec de sauvegarde de %s", saver->file_name);
			else
				Dialog_global_print(get_screen(), "Fichier bien sauvegardé");
		}
		Key_Gest_key_clean(key_gest);
		return 1;
	}
	return 0;
}

int FileSaver_load(FileSaver * saver, File_Explorer explorer, Key_Gest * key_gest, void * data, int (*load_function)(const char * path, void * data))
{
	if(Key_Gest_key_in(key_gest, KGK_CTRL))
	{
		saver->file_name = NULL;
		File_Explorer_gest_event(explorer, get_screen(), FILE_EXPLORER_MODE_LOAD, &(saver->file_name));
		if(saver->file_name != NULL)
		{
			if(! (*load_function)(saver->file_name, data))
				Dialog_global_print(get_screen(), "Echec du chargement de %s", saver->file_name);
		}
		Key_Gest_key_clean(key_gest);
		return 1;
	}
	return 0;
}