#ifndef DEF_HEADER_GAME
#define DEF_HEADER_GAME

#include "menu.h"
#include "personnage.h"

typedef enum {
	GPI_NULL,
	GPI_PLAYER,
	GPI_ADV
} GamePersoId;

typedef struct _Game Game;
struct _Game
{
	Menu player_menu;
	Menu adv_menu;
	Menu main_menu;
	
	Personnage player;
	Personnage adv;
	
	Personnage player_fighter;
	Personnage adv_fighter;
};

int Game_play();

int Game_init(Game * game);

void Game_quit(Game * game);

int Game_gest_menu(Game * game);

int Game_create_perso(Game * game, Personnage * perso, GamePersoId id);

int Game_load_perso(Game * game, Personnage * perso, GamePersoId id);

int Game_edit_perso(Game * game, Personnage * perso, GamePersoId id);

int Game_start_fight(Game * game);

int Game_make_fighter(Game * game, GamePersoId id);

#endif