#include "generic_meca.h"

#include <stdio.h>
#include <stdlib.h>

int TreeChildBrother_generic_append(void * dest, int (*create_fct)(void *), int child, int brother, void * appened)
{
	char ** cur = NULL;
	if(dest == NULL)
		return 0;
		
	if(*((char **)dest) == NULL)
	{
		if(! (*create_fct)(dest))
			return 0;
		if(appened != NULL)
			*((char **)appened) = *((char **)dest);
		return 1;
	}

	for(cur = (char **)(*((char **)dest) + child); *cur != NULL; cur = (char **)(*((char **)cur) + brother));
	/* get the last NULL son adress */

	if(! (*create_fct)(cur))
		return 0;
	if(appened != NULL)
		*((char **)appened) = *cur;
	return 1;
}

int TreeChildBrother_generic_delete(void * dest, void * del, void (*free_fct)(void *), int child, int brother, void * (*get_next)(void * target, void * current_adress))
{
	void * next_adress = NULL;
	if(dest == NULL || *((char **)dest) == NULL || (char *)del == NULL)
		return 0;
	if(*((char **)dest) == (char *)del)
	{
		if(*((char **)(*((char **)dest) + child)) != NULL) /* child exists */
		{
			if(*((char **)(*((char **)dest) + brother)) != NULL) /* brother exists */
			{
				char ** cur = NULL;
				for(cur = (char **)(*((char **)dest) + child); *cur != NULL; cur = (char **)(*((char **)cur) + brother));
				/* get the last NULL son adress */
				
				*cur = *((char **)(*((char **)dest) + brother));
				/* the last son becomes dest's first brother*/
			}
			*((char **)dest) = *((char **)(*((char **)dest) + child));
			/* Now the children are brothers of dest's brothers, his first son becomes the first element of the tree */
		}
		else
			*((char **)dest) = *((char **)(*((char **)dest) + brother));
			/* dest has no child, his brother becomes the first element of the tree */
			
		*((char **)((char *)del + child)) = NULL;
		*((char **)((char *)del + brother)) = NULL;
		(*free_fct)(&del);
		return 1;
	}
	if(get_next != NULL && (next_adress = (*get_next)(del, dest)) != NULL) /* In case a function giving the path is given and its able to find a next element */
	{
		if(TreeChildBrother_generic_delete(next_adress, del, free_fct, child, brother, get_next))
			return 1;
	}
	else
	{
		if(TreeChildBrother_generic_delete(*((char **)dest) + child, del, free_fct, child, brother, NULL))
			return 1;
		if(TreeChildBrother_generic_delete(*((char **)dest) + brother, del, free_fct, child, brother, NULL))
			return 1;
	}
	return 0;
}