#ifndef DEF_HEADER_HITBOX
#define DEF_HEADER_HITBOX

#include <SDL/SDL.h>

#include "shape.h"

#define BONE_HITBOX 20
#define HB_GROW_LIM 8

typedef struct _HitBox * HitBox;
struct _HitBox
{
	SDL_Rect center;
	int radius;
	HitBox brother;
	HitBox child;
	
	SDL_Rect rotated_center;
};

int HitBox_create(HitBox * hitbox, int x, int y, int radius);

void HitBox_free(HitBox * hitbox);

int HitBox_set_center(HitBox hitbox, int x, int y);

int HitBox_set_radius(HitBox hitbox, int radius);

void HitBox_rotate(HitBox hitbox, double angle);

int HitBox_append(HitBox * hitbox, HitBox * appened, int x, int y, int radius);

int HitBox_delete(HitBox * hitbox, HitBox del);

int HitBox_copy(HitBox * copy, HitBox hitbox);

int HitBox_generate(HitBox * hitbox, SDL_Rect bone_start, SDL_Rect bone_end, ShapeSet shape);

int HitBox_dimensions_aux(HitBox hitbox, int * x_min, int * y_min, int * x_max, int * y_max, int x, int y);

int HitBox_dimensions(HitBox hitbox, int * x_min, int * y_min, int * x_max, int * y_max);

int HitBox_check_collision(HitBox first, HitBox second, int first_x, int first_y, int second_x, int second_y);

#endif