#ifndef DEF_HEADER_KEY_GEST
#define DEF_HEADER_KEY_GEST

#include <SDL/SDL.h>

typedef enum
{
	KGK_NULL = 0x0,
	KGK_RCTRL = 0x1,
	KGK_LCTRL = 0x2,
	KGK_CTRL = 0x3,
	KGK_RSHIFT = 0x4,
	KGK_LSHIFT = 0x8,
	KGK_SHIFT = 0xC,
	KGK_LALT = 0x10,
	KGK_RALT = 0x20,
	KGK_ALT = 0x30
} Key_Gest_Key;

typedef struct _Key_Gest Key_Gest;
struct _Key_Gest
{
	Key_Gest_Key key;
};

Key_Gest Key_Gest_create();

int Key_Gest_key_in(Key_Gest * gest, Key_Gest_Key key);

int Key_Gest_key_append(Key_Gest * gest, Key_Gest_Key key);

int Key_Gest_key_delete(Key_Gest * gest, Key_Gest_Key key);

int Key_Gest_key_clean(Key_Gest * gest);

int Key_Gest_event(Key_Gest * gest, SDL_Event * event);

int Key_Gest_equal(const Key_Gest * self, const Key_Gest * other);

int Key_Gest_save(FILE * flow, const Key_Gest * gest);

int Key_Gest_load(FILE * flow, Key_Gest * gest);

#endif