#ifndef DEF_HEADER_MATH
#define DEF_HEADER_MATH

#include <SDL/SDL.h>
#include <math.h>

#ifndef M_PI
#define M_PI 3.14159265359
#endif

double carre_float(double x);

double abs_float(double x);

double min_float(double a, double b);

int carre(int x);

int distance_carre(int x, int y, int target_x, int target_y);

int distance_carre_droite(int x, int y, int t1x, int t1y, int t2x, int t2y);

int distance_carre_segment(int x, int y, int t1x, int t1y, int t2x, int t2y);

double angle_segment(int x1, int y1, int x2, int y2);

double degre_to_rad(double degre);

double rad_to_degre(double rad);

double correct_degre_angle(double degre);

double correct_rad_angle(double degre);

int in_angle_area(double area_start, double area_width, double deg_angle);

double distance_angles(double degre, double value);

int get_external_tangents_from_circles(int a_radius, SDL_Rect a_center, int b_radius, SDL_Rect b_center, int * pa1_x, int * pa1_y, int * pa2_x, int * pa2_y, int * pb1_x, int * pb1_y, int * pb2_x, int * pb2_y);
/*
	       pa1
	    ****---
	  **    ** -------   pb1
	 *        *       --**
	*     ca   *       *cb*
	*          *       *  *
	 *        *       --**
	  **    ** -------   pb2
	    ****---
	       pa2
*/

int in_triangle(int x, int y, int x1, int y1, int x2, int y2, int x3, int y3);

int coordX_in_circle(int x, int y, int radius, double angle);

int coordY_in_circle(int x, int y, int radius, double angle);

SDL_Rect coord_in_circle(int x, int y, int radius, double angle);

int max_int(int nb, ...);

int min_int(int nb, ...);

void get_coord_by_rotation(int * nx, int * ny, int x, int y, int center_x, int center_y, double rad_angle);

SDL_Rect get_SDL_Rect_by_rotation(SDL_Rect coord, SDL_Rect center, double rad_angle);

int circle_in_circle(int a_x, int a_y, int a_r, int b_x, int b_y, int b_r);

int degre_same(double first, double second);

int rad_same(double first, double second);

float parabole_y(float x, float x1, float x2, float h);

int box_collision(int ax1, int ay1, int ax2, int ay2, int bx1, int by1, int bx2, int by2);

int circle_collision(int x1, int y1, int rad1, int x2, int y2, int rad2);

int speed_circle_collision_box(int x, int y, int rad, int x1, int y1, int x2, int y2);

int circle_collision_segment(int x, int y, int rad, int x1, int y1, int x2, int y2);

#endif