#ifndef DEF_HEADER_MENU_LIST
#define DEF_HEADER_MENU_LIST

#include "menu.h"
#include <SDL/SDL_ttf.h>

#define ML_SCROLL_ADD 25

typedef enum
{
	MENU_LIST_ALIGN_LEFT,
	MENU_LIST_ALIGN_CENTER,
	MENU_LIST_ALIGN_RIGHT,
	NB_MENU_ALIGN
} Menu_List_Align;

/* Menu Liste user data */
typedef struct _Menu_List * Menu_List;
struct _Menu_List
{
	SDL_Surface * background;
	SDL_Surface * background_hover;
	SDL_Surface ** text_images;
	int nb_text_images;
	TTF_Font * font;
	SDL_Color font_color;
	Menu_List_Align align;
	int scroll;
};

int Menu_define_Menu_List(Menu menu, const char * font_path, int font_size, SDL_Color font_color, SDL_Surface * background, SDL_Surface * background_hover);

int Menu_List_set_align(Menu menu, Menu_List_Align align);

void Menu_List_reset_scroll(Menu menu);

#endif