#ifndef DEF_HEADER_MINI_MENU
#define DEF_HEADER_MINI_MENU

#include <SDL/SDL.h>
#include "key_gest.h"

typedef struct _Mini_Menu * Mini_Menu;
struct _Mini_Menu
{
	SDL_Rect origin;
	SDL_Surface * button_background;
	SDL_Surface * button_background_hover;
	SDL_Surface ** text_images;
	void * functions; /* list of functions */
	int options_count;
	int last_hover;
};

int Mini_Menu_create(Mini_Menu * menu);

void Mini_Menu_free(Mini_Menu * menu);

int Mini_Menu_set_origin(Mini_Menu menu, int x, int y);

int Mini_Menu_set_origin_on_screen(Mini_Menu menu, int x, int y, SDL_Surface * screen);

int Mini_Menu_set_button_background(Mini_Menu menu, SDL_Surface * background, SDL_Surface * background_hover);

/*
	after count, write the list of [const char * option_name, void * option_function] times (count - 1)
*/
int Mini_Menu_configure(Mini_Menu menu, const char * font_path, int font_size, SDL_Color color, int count, ...);

void Mini_Menu_draw(Mini_Menu menu, SDL_Surface * screen);

/*
	get_function is the function pointer's adress, which will be edit if the event imply function use
*/
int Mini_Menu_event(Mini_Menu menu, SDL_Event * event, void * get_function, int * exit_menu);

int Mini_Menu_gest(Mini_Menu menu, SDL_Surface * screen, void * get_function, Key_Gest * key);

int Mini_Menu_width(Mini_Menu menu);

int Mini_Menu_height(Mini_Menu menu);

#endif