#ifndef DEF_HEADER_SHAPE_LIST
#define DEF_HEADER_SHAPE_LIST

#include <SDL/SDL.h>
#include "shape.h"

#define SL_SCROLL_ADD 25

typedef enum
{
	SHAPELIST_ACTION_NULL,
	SHAPELIST_ACTION_SCROLL,
	SHAPELIST_ACTION_APPEND,
	SHAPELIST_ACTION_GET,
	NB_SHAPELIST_ACTION
} ShapeList_Action;

typedef struct _ShapeList * ShapeList;
struct _ShapeList
{
	ShapeSet * tab;
	int nb_elems;
	int maxi_elems;
	SDL_Rect origin;
	SDL_Rect size;
	int visible;
	int in_add_box;
	SDL_Surface * background;
	int select_shape;
	int scroll;
};

int ShapeList_create(ShapeList * list);

void ShapeList_free(ShapeList * list);

int ShapeList_set_origin(ShapeList list, int x, int y);

int ShapeList_set_size(ShapeList list, int w, int h);

int ShapeList_set_background(ShapeList list, SDL_Surface * background);

int ShapeList_set_background_sizedRGB(ShapeList list, int r, int g, int b);

int ShapeList_append(ShapeList list, ShapeSet shape);

int ShapeList_delete(ShapeList list, int id);

int ShapeList_clean(ShapeList list);

int ShapeList_get_id_by_coords(ShapeList list, int x, int y);

int ShapeList_in(ShapeList list, int x, int y);

int ShapeList_draw(ShapeList list);

int ShapeList_event(ShapeList list, SDL_Event * event, ShapeList_Action * get_action);

int ShapeList_get_join(ShapeList list, ShapeSet dest);

int ShapeList_save(FILE * ecr, ShapeList list);

int ShapeList_load(FILE * lec, ShapeList list);

int ShapeList_save_in_file(const char * path, ShapeList list);

int ShapeList_load_from_file(const char * path, ShapeList list);

#endif